class BibBucket {

 ArrayList< Bib > bibs = new ArrayList< Bib >();
 HashMap< String, Float > sums = new HashMap< String, Float >();
 HashMap< String, Float > mins = new HashMap< String, Float >();
 HashMap< String, Float > maxs = new HashMap< String, Float >();
 
 BucketGrid masterGrid;
 
 String range = "";
 
 BibBucket( BucketGrid g ) {
   masterGrid = g;
 }
 
 void addBib( Bib newBib ) {
   bibs.add( newBib );
   
   for ( int i = 0; i < masterGrid.attributes.length; i++ ) {
    if ( sums.get( masterGrid.attributes[ i ] ) == null ) {
      sums.put( masterGrid.attributes[ i ], 0.0 );
      mins.put( masterGrid.attributes[ i ], MAX_FLOAT );
      maxs.put( masterGrid.attributes[ i ], MIN_FLOAT );
    }
    
    sums.put( masterGrid.attributes[ i ], sums.get( masterGrid.attributes[ i ] ) + newBib.data.get( masterGrid.attributes[ i ] ) );
    mins.put( masterGrid.attributes[ i ], min( mins.get( masterGrid.attributes[ i ] ), newBib.data.get( masterGrid.attributes[ i ] ) ) );
    maxs.put( masterGrid.attributes[ i ], max( maxs.get( masterGrid.attributes[ i ] ), newBib.data.get( masterGrid.attributes[ i ] ) ) );
    
   }

 }
 
 float getAverage( String attribute ) {
   if ( sums.size() > 0 )
     return sums.get( attribute ) / bibs.size();
   else
     return 0;
 }
 
 float getMin( String attribute ) {
   if ( mins.size() > 0 )
    return mins.get( attribute ); 
  else
   return 0;
 }
 
 float getMax( String attribute ) {
   if ( maxs.size() > 0 )
    return maxs.get( attribute ); 
   else
     return 0;
 }
 
}
