class BibTreeItem extends SimpleMapItem {
  BibBucket bucket;
  String topic = "NA";
  float colorVal;
  PFont itemFont = createFont( "Calibri", 12, true);
  
  BibTreeItem( BibBucket b, BucketGrid g ) {
    bucket = b;
    this.topic = b.range;//b.getMin( "topic" ) + "\n-\n" + b.getMax( "topic" );
    this.colorVal = b.getAverage( "controversy" ) / g.maxByBucket.get( "controversy" ); //  needs to be max controversy for any BUCKET
//    println( "SET COLORVAL TO: " + g.maxs.get( "controversy" ) );
    this.setSize( b.getAverage( "pops" ) );
  }
  
  void draw() {
    colorMode( HSB );
    stroke( 0 );
    strokeWeight( 2.0 );
    
    textFont( itemFont );
    fill( 128, floor( 5 + colorVal * 205 ), floor( 50 + colorVal * 205 ) );
    
    if ( ( mouseX > x ) && ( mouseX < x + w ) && ( mouseY > y ) && ( mouseY < y + h ) ) {
      fill( 200, floor( 50 + colorVal * 205 ), floor( 50 + colorVal * 205 ) );
      controversy_v2.headerDodString = topic;
      controversy_v2.dodString = "Most Controversial\n\n";
      for ( int i = 0; i < min( bucket.bibs.size(), 5 ); i++ ) {
        controversy_v2.dodString += bucket.bibs.get( i ).title + "\n\n";
      }
    }
   
    rect(x, y, w, h);
    if ( colorVal >= 0.5 )
      fill(0);
    else
      fill( 255 );    
    textAlign(CENTER, CENTER);
    text(topic, x + 5, y + 5 , w - 10, h - 10 );
   
  }
  
}
