import java.util.Collections;

class BucketGrid {

 String[] attributes = { "pops", "pages", "topic", "rating", "checkoutAverage", "checkoutVariance", "controversy" };
 
 BibBucket buckets[][];
 ArrayList< Bib > allBibs;

 FloatDict mins;
 FloatDict maxs;
 FloatDict maxByBucket;
 
 Table ddcTable;

StringDict ddc = new StringDict();
 
 BucketGrid( Table t ) {
   
   ddcTable = t;
   for ( TableRow row : t.rows() ) {
    ddc.set( "" + row.getInt( "dewey" ), row.getString( "topic" )/*.replace( " ", "\n" )*/  );
  }
   
   mins = new FloatDict();
   maxs = new FloatDict();
   maxByBucket = new FloatDict();
   
   allBibs = new ArrayList< Bib >();
   
   for ( int i = 0; i < attributes.length; i++ ) {
    mins.set( attributes[ i ], MAX_FLOAT );
    maxs.set( attributes[ i ], MIN_FLOAT );
    maxByBucket.set( attributes[ i ], MIN_FLOAT );
   }
   
 }
 
 void addBib( TableRow t ) {
   Bib newBib = new Bib( t, this );
   for ( int i = 0; i < attributes.length; i++ ) {
     float oldMin = mins.get( attributes[ i ] );
     float oldMax = maxs.get( attributes[ i ] );
     float newValue = newBib.data.get( attributes[ i ] );
     mins.set( attributes[ i ], min( oldMin, newValue ) );
     maxs.set( attributes[ i ], max( oldMax, newValue ) );
   }
   
   allBibs.add( newBib );
   
 }
 
 void layout( String columnProperty, String rowProperty, int columnSize, int rowSize, int columnStart, int rowStart, int columnEnd, int rowEnd ) {

   float columnInterval = ( columnEnd - columnStart ) / columnSize;   
   float rowInterval = ( rowEnd - rowStart ) / rowSize;
   buckets = new BibBucket[ columnSize ][ rowSize ];
   for ( int i = 0; i < columnSize; i++ ) {
     for ( int j = 0; j < rowSize; j++ ) {
       buckets[ i ][ j ] = new BibBucket( this );
        if ( ddc.get( "" + (int) (floor( i * columnInterval ) ) ) != null ) {
          buckets[ i ][ j ].range = ddc.get( "" + (int)(floor( i * columnInterval ) ) );
        }
        buckets[ i ][ j ].range += "\n" + ( (int) ( i * columnInterval ) );
     }
   }
   
   for ( int i = 0; i < allBibs.size(); i++ ) {
     allBibs.get( i ).validateControversy();
     
     int nextRow = min( floor( ( allBibs.get( i ).data.get( rowProperty ) - rowStart ) / rowInterval ), rowSize - 1 );
     int nextColumn = min( floor( ( allBibs.get( i ).data.get( columnProperty ) - columnStart ) / columnInterval ), columnSize - 1 );
     
     buckets[ nextColumn ][ nextRow ].addBib( allBibs.get( i ) );
   }
   
   for ( int i = 0; i < columnSize; i++ ) {
    for ( int j = 0; j < rowSize; j++ ) {
     Collections.sort( buckets[ i ][ j ].bibs );
    } 
   }
   
   for ( int i = 0; i < attributes.length; i++ ) {
     for ( int j = 0; j < columnSize; j++ ) {
       for ( int k = 0; k < rowSize; k++ ) {
         maxByBucket.set( attributes[ i ], max( maxByBucket.get( attributes[ i ] ), buckets[ j ][ k ].getAverage( attributes[ i ] ) ) );
       }
     } 
   }
   
   println( "allbibs size: " + allBibs.size() );
 }
 
 String summary() {
  String result = "";
  for ( int i = 0; i < attributes.length; i++ ) {
    result += attributes[ i ] + " :: " + mins.get( attributes[ i ] ) + " :: " + maxs.get( attributes[ i ] ) + "\n";
  } 
  return result;
 }
  
}
